package com.syjy.calculate.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;
import java.io.Serializable;
import java.util.Date;

/**
 * 计算公式
 *
 * @author zcl
 * @version 1.0
 * @since 2022/8/02 10:16
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class CalculationFormula extends PageReq {

    /**
     * 公式编号（运维标识，主键）
     */
    private static final long serialVersionUID = 1L;

    private Integer id;

    /**
     * 公式类型
     */
    private String type;

    /**
     * 公式执行顺序
     */
    private Integer orderNo;

    /**
     * 公式内容
     */
    private String formula;

    /**
     * 上报省调
     */
    private String province;

    /**
     * 场站类型
     */
    private String electricType;

    /**
     * 细则对应的公式
     */
    private String ruleFormula;

    /**
     * 是否为百分比
     */
    private String isRate;


    /**
     * 状态
     */

    private String state;
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date createTime;

    private String creator;

    private String lastModifier;
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date lastModifyTime;
}
