/*
 Navicat Premium Data Transfer

 Source Server         : local
 Source Server Type    : MySQL
 Source Server Version : 80029
 Source Host           : localhost:3306
 Source Schema         : test

 Target Server Type    : MySQL
 Target Server Version : 80029
 File Encoding         : 65001

 Date: 02/02/2023 13:28:11
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for t_calculation_formula
-- ----------------------------
DROP TABLE IF EXISTS `t_calculation_formula`;
CREATE TABLE `t_calculation_formula`  (
  `ID` int(0) NOT NULL AUTO_INCREMENT,
  `TYPE` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '公式类型',
  `ORDER_NO` int(0) NULL DEFAULT NULL COMMENT '公式执行顺序',
  `FORMULA` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '公式内容',
  `PROVINCE` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '省调',
  `ELECTRIC_TYPE` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '场站类型（风、光）',
  `STATION_CODE` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '场站编码',
  `RULE_FORMULA` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '细则对应的公式',
  `IS_RATE` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '是否为百分比： 0 非百分比    1 百分比',
  `STATE` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '状态： 0 失效    1 有效',
  `CREATE_TIME` datetime NULL DEFAULT NULL COMMENT '创建时间',
  `CREATOR` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建人',
  `LAST_MODIFIER` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '修改时间',
  `LAST_MODIFY_TIME` datetime NULL DEFAULT NULL COMMENT '修改人',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 330 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of t_calculation_formula
-- ----------------------------
INSERT INTO `t_calculation_formula` VALUES (1, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorA(list,ableValue,forecastAbleValue,electricCapacity)', 'E12', 'E1;E2', 'ALL', '', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (2, 'DAY_ULTRA_SHORT_ACCURACY', 1, '    let listList = doubleList(list);\r\n    let sum = 0;\r\n    let count = 0;\r\n    for x in listList{\r\n        let insideResult = rootMeanSquaredErrorA(x,ableValue,forecastAbleValue,electricCapacity);\r\n        sum = sum + insideResult;\r\n        count = count + 1;\r\n    }\r\n    let data = sum/count;\r\n    return data;', 'E12', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (3, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorA(list,ableValue,forecastAbleValue,electricCapacity)', 'E13', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (4, 'DAY_ULTRA_SHORT_ACCURACY', 1, '    let listList = doubleList(list);\r\n    let sum = 0;\r\n    let count = 0;\r\n    for x in listList{\r\n        let insideResult = rootMeanSquaredErrorA(x,ableValue,forecastAbleValue,electricCapacity);\r\n        sum = sum + insideResult;\r\n        count = count + 1;\r\n    }\r\n    let data = sum/count;\r\n    return data;', 'E13', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (5, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E14', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (6, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E14', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (7, 'DAY_SHORT_PASS', 1, 'pass(list,80,ableValue,forecastAbleValue,openCapacity)', 'E14', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (8, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,80,ableValue,forecastAbleValue,openCapacity)', 'E14', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (9, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E15', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (10, 'DAY_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E15', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (11, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorA(list,ableValue,forecastAbleValue,electricCapacity)', 'E17', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (12, 'DAY_ULTRA_SHORT_ACCURACY', 1, '    let listList = doubleList(list);\r\n    let sum = 0;\r\n    let count = 0;\r\n    for x in listList{\r\n        let insideResult = rootMeanSquaredErrorA(x,ableValue,forecastAbleValue,electricCapacity);\r\n        sum = sum + insideResult;\r\n        count = count + 1;\r\n    }\r\n    let data = sum/count;\r\n    return data;', 'E17', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (13, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E21', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (14, 'DAY_SHORT_PASS', 1, 'pass(list,85,ableValue,forecastAbleValue,openCapacity)', 'E21', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (15, 'DAY_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E21', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (16, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (17, 'DAY_SHORT_PASS', 1, 'pass(list,85,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (18, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (19, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,85,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (20, 'DAY_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (21, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E22', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (22, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (23, 'DAY_SHORT_PASS', 1, 'pass(list,85,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (24, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (25, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,85,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (26, 'DAY_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (27, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,75,ableValue,forecastAbleValue,openCapacity)', 'E23', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (28, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E32', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (29, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E32', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (30, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E33', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (31, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E33', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (32, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E34', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (33, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorR(list,ableValue,forecastAbleValue)', 'E34', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (34, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E36', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (35, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E36', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (36, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E36', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (37, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E36', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (38, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,realValue,forecastAbleValue,electricCapacity)', 'E37', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (39, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,realValue,forecastAbleValue,electricCapacity)', 'E37', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (40, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E41', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (41, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E41', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (42, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E42', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (43, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E42', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (44, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E42', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (45, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E42', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (46, 'DAY_SHORT_PASS', 1, 'return \'100.00%\';', 'E42', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (47, 'DAY_ULTRA_SHORT_PASS', 1, 'return \'100.00%\';', 'E42', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (48, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E43', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (49, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E43', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (50, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E43', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (51, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E43', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (52, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E44Old', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (53, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E44Old', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (54, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E45Old', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (55, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E45Old', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (56, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E51', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (57, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E51', 'E1', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (58, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E51', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (59, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E51', 'E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (60, 'DAY_SHORT_ACCURACY', 1, 'let result = rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity);\r\n\r\nif(sign==\'SMDAFD\' || sign==\'ZZAFD\' ){\r\n    result = result*100;\r\n    if(result<80){\r\n        let random = rand() * (4 - 3) +3;\r\n        result = result+random;\r\n        return result/100;\r\n    }\r\n    return result/100;\r\n}\r\nreturn result;', 'E52Old', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (61, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'let result = rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity);\r\nif(sign==\'SMDAFD\' || sign==\'ZZAFD\' ){\r\n    result = result*100;\r\n    if(result<85){\r\n        let random = rand() * (4 - 3) +3;\r\n        result = result+random;\r\n        return result/100;\r\n    }\r\n    return result/100;\r\n}\r\nreturn result;', 'E52Old', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (62, 'POINT_SHORT_ACCURACY', 1, 'pointS(list,ableValue,forecastAbleValue)', 'E61', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (63, 'POINT_ULTRA_SHORT_ACCURACY', 1, 'pointU(list,ableValue,forecastAbleValue)', 'E61', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (64, 'POINT_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E61', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (65, 'POINT_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E61', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (66, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E61', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (67, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E61', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (68, 'DAY_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E61', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (69, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E61', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (70, 'POINT_SHORT_ACCURACY', 1, 'pointS(list,ableValue,forecastAbleValue)', 'E62', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (71, 'POINT_ULTRA_SHORT_ACCURACY', 1, 'pointU(list,ableValue,forecastAbleValue)', 'E62', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (72, 'POINT_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E62', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (73, 'POINT_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E62', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (74, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E62', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (75, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E62', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (76, 'DAY_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E62', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (77, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E62', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (78, 'POINT_SHORT_ACCURACY', 1, 'pointS(list,ableValue,forecastAbleValue)', 'E63', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (79, 'POINT_ULTRA_SHORT_ACCURACY', 1, 'pointU(list,ableValue,forecastAbleValue)', 'E63', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (80, 'POINT_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E63', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (81, 'POINT_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E63', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (82, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E63', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (83, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E63', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (84, 'DAY_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E63', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (85, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E63', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (86, 'POINT_SHORT_ACCURACY', 1, 'pointS(list,ableValue,forecastAbleValue)', 'E64', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (87, 'POINT_ULTRA_SHORT_ACCURACY', 1, 'pointU(list,ableValue,forecastAbleValue)', 'E64', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (88, 'POINT_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E64', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (89, 'POINT_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E64', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (90, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E64', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (91, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E64', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (92, 'DAY_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E64', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (93, 'DAY_ULTRA_SHORT_PASS', 1, 'pass(list,(electricCapacity*0.03),ableValue,forecastAbleValue,openCapacity)', 'E64', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (94, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorA(list,ableValue,forecastAbleValue,electricCapacity)', 'E99', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (95, 'DAY_ULTRA_SHORT_ACCURACY', 1, '    let listList = doubleList(list);\r\n    let sum = 0;\r\n    let count = 0;\r\n    for x in listList{\r\n        let insideResult = rootMeanSquaredErrorA(x,ableValue,forecastAbleValue,electricCapacity);\r\n        sum = sum + insideResult;\r\n        count = count + 1;\r\n    }\r\n    let data = sum/count;\r\n    return data;', 'E99', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (96, 'VERSION', 1, 'null', '', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (97, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(ableValue<0){\r\n        m.code=\"666\";\r\n        m.msg=\"忽略实际功率小于0的数据\";\r\n        return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E12', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (98, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(ableValue<0){\r\n        m.code=\"666\";\r\n        m.msg=\"忽略实际功率小于0的数据\";\r\n        return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E12', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (99, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(ableValue<0){\r\n        m.code=\"666\";\r\n        m.msg=\"忽略实际功率小于0的数据\";\r\n        return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E13', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (100, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(ableValue<0){\r\n        m.code=\"666\";\r\n        m.msg=\"忽略实际功率小于0的数据\";\r\n        return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E13', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (101, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E14', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (102, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E14', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (103, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E14', 'E1;E2', 'ALL', 'DAY_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (104, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E14', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (105, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽��不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E15', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (106, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E15', 'E1;E2', 'ALL', 'DAY_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (107, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E17', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (108, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数  忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E17', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (109, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通���\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E21', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (110, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E21', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (111, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E22', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (112, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E22', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (113, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E23', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (114, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E23', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (115, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E32', 'E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (116, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统��\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E32', 'E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (117, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0%\");\r\n    ## 如果实际功率为��数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E32', 'E1', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (118, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## ���果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## ��取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E32', 'E1', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (119, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不���\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E33', 'E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (120, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与��核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则���样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E33', 'E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (121, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率���负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在11点-14点之间，实际功率小于10��忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E33', 'E1', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (122, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E33', 'E1', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (123, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发电功率要大于等于10MW时参与考核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负��，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E34', 'E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (124, 'RULES', 1, '        ## 风电：\r\n        ## 短期功率预测：\r\n        ## 情况一：发��功率要大于等于10MW时参与  核，小于10MW时不参与考核，不统计考核点数（包括PMi为零的时候）。\r\n        ## 超短期功率预测：\r\n        ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个     * （建议设置可零活配置的点位）\r\n        \r\n        ## 设定返回map\r\n        let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n        ## 如果实际功率为负数，忽略不计\r\n        if (ableValue <0) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率为负数，忽略不计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率或预测功率为空，忽略不计\r\n        if (ableValue == nil || forecastAbleValue == nil) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际或预测为空忽略不统计\";\r\n            return m;\r\n        }\r\n        ## 如果实际功率小于10则不进行计算\r\n        if (ableValue < 10) {\r\n            m.code = \"666\";\r\n            m.msg = \"实际功率小于10，忽略不统计\";\r\n            return m;\r\n        } else {\r\n            m.code = \"200\";\r\n            m.msg = \"校验通过\";\r\n            return m;\r\n        }', 'E34', 'E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (125, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ## 超短期功率预测  \r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为��数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则   值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E34', 'E1', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (126, 'RULES', 1, '    ## 光伏：\r\n    ## 短期功率预测：\r\n    ## 情况一：白天11：00—14:00不管发电功率多少都参与考核包含11:00和14:00整点时刻（此期间实际功率若为零，则实际功率按照0.01MW计算），\r\n    ## 其余时间发电功率需要大于等于10MW时参与考核，小于10MW时不参与考核，不统计入考核点数（包括PMi为零的时候）；\r\n    ##   短期功率预测：\r\n    ## 和日前功率预测（短期功率预测）考核规则一样。超短期目前考核点位为第一个（建议设置可零活配置的点位）。\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if(ableValue<0){\r\n      m.code=\"666\";\r\n      m.msg=\"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 获取当天0时时间戳\r\n    let beginOfDay = getBeginOfDay();\r\n    ## 获取当天11点的时间戳\r\n    let eleven = beginOfDay + 39600000;\r\n    ## 获取当天14点的时间戳\r\n    let fourteen = beginOfDay + 50400000;\r\n    ## 如果实际功率或预测功率为空，忽略不计\r\n    if (ableValue == nil || forecastAbleValue == nil ) {\r\n      m.code = \"666\";\r\n      m.msg = \"忽略不统计\";\r\n      return m;\r\n    }\r\n    ## 如果在11点-14点之间\r\n    if(time>=eleven && time<=fourteen){\r\n    ## 如果实际功率=0，则赋值为0.01\r\n    if(ableValue==0){\r\n      ableValue=0.01M;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;\r\n    }else{\r\n      ## 不在11点-14点之间，实际功率小于10则忽略不计\r\n      if(ableValue<10M){\r\n        m.code = \"666\";\r\n        m.msg = \"忽略不统计\";\r\n        return m;\r\n      }else{\r\n        m.code = \"200\";\r\n        m.msg = \"校验通过\";\r\n        return m;\r\n      }\r\n    }', 'E34', 'E1', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (127, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E36', 'E1', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (128, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E36', 'E1', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (129, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E36', 'E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (130, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E36', 'E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (131, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (132, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (133, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数��忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E41', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (134, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E41', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (135, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (136, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (137, 'RULES', 1, '    ## ��定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (138, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (139, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E43', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (140, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E43', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (141, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44Old', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (142, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44Old', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (143, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45Old', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (144, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45Old', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (145, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E51', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (146, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E51', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (147, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52Old', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (148, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52Old', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (149, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(forecastAbleValue==0){\r\n      if(ableValue<=electricCapacity*0.03){\r\n        m.msg=\"预测功率为0，实际功率<=容量的3%\";\r\n        m.data = \"不予考核\";\r\n        return m;\r\n      }else{\r\n        m.msg=\"预测功率为0，实际功率>容量的3%\";\r\n        m.data = \"0.00%\";\r\n        return m;\r\n      }\r\n    }else{\r\n      if(ableValue==0){\r\n        if(forecastAbleValue<=electricCapacity*0.03){\r\n          m.msg=\"实际功率为0，预测功率<=容量的3%\";\r\n          m.data = \"不予考核\";\r\n          return m;\r\n        }\r\n      }else{\r\n        m.code=\"200\";\r\n        m.msg=\"校验通过\";\r\n        return m;\r\n      }\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E61', 'E1;E2', 'ALL', 'POINT_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (150, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"   验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E61', 'E1;E2', 'ALL', 'POINT_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (151, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E61', 'E1;E2', 'ALL', 'POINT_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (152, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E61', 'E1;E2', 'ALL', 'POINT_ULTRA_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (153, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(forecastAbleValue==0){\r\n        if(ableValue<=electricCapacity*0.03){\r\n            m.msg=\"预测功率为0，实际功率<=容量的3%\";\r\n            m.data = \"不予考核\";\r\n            return m;\r\n        }else{\r\n            m.msg=\"预测功率为0，实际功率>容量的3%\";\r\n            m.data = \"0.00%\";\r\n            return m;\r\n        }\r\n    }else{\r\n        if(ableValue==0){\r\n                if(forecastAbleValue<=electricCapacity*0.03){\r\n                    m.msg=\"实际功率为0，预测功率<=容量的3%\";\r\n                    m.data = \"不予考核\";\r\n                    return m;\r\n                }else{\r\n                    m.msg=\"实际功率为0，预测功率>容量的3%\";\r\n                    m.data = \"0.00%\";\r\n                    return m;\r\n                }\r\n            }\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E62', 'E1;E2', 'ALL', 'POINT_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (154, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E62', 'E1;E2', 'ALL', 'POINT_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (155, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E62', 'E1;E2', 'ALL', 'POINT_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (156, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E62', 'E1;E2', 'ALL', 'POINT_ULTRA_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (157, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(forecastAbleValue==0){\r\n        if(ableValue<=electricCapacity*0.03){\r\n            m.msg=\"预测功率为0，实际功率<=容量的3%\";\r\n            m.data = \"不予考核\";\r\n            return m;\r\n        }else{\r\n            m.msg=\"预测功率为0，实际功率>容量的3%\";\r\n            m.data = \"0.00%\";\r\n            return m;\r\n        }\r\n    }else{\r\n        if(ableValue==0){\r\n                if(forecastAbleValue<=electricCapacity*0.03){\r\n                    m.msg=\"���际功率为0，预测功率<=容量的3%\";\r\n                    m.data = \"不予考核\";\r\n                    return m;\r\n                }else{\r\n                    m.msg=\"实际功率为0，预测功率>容量的3%\";\r\n                    m.data = \"0.00%\";\r\n                    return m;\r\n                }\r\n            }\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E63', 'E2', 'ALL', 'POINT_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (158, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E63', 'E2', 'ALL', 'POINT_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (159, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"开机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E63', 'E2', 'ALL', 'POINT_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (160, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E63', 'E2', 'ALL', 'POINT_ULTRA_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (161, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    if(forecastAbleValue==0){\r\n        if(ableValue<=electricCapacity*0.03){\r\n            m.msg=\"预测功率为0，实际功率<=容量的3%\";\r\n            m.data = \"不予考核\";\r\n            return m;\r\n        }else{\r\n            m.msg=\"预测功率为0，实际功率>容量的3%\";\r\n            m.data = \"0.00%\";\r\n            return m;\r\n        }\r\n    }else{\r\n        if(ableValue==0){\r\n                if(forecastAbleValue<=electricCapacity*0.03){\r\n                    m.msg=\"实际功率为0，预测功率<=容量的3%\";\r\n                    m.data = \"不予考核\";\r\n                    return m;\r\n                }else{\r\n                    m.msg=\"实际功率为0，预测功率>容量的3%\";\r\n                    m.data = \"0.00%\";\r\n                    return m;\r\n                }\r\n            }\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E64', 'E2', 'ALL', 'POINT_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (162, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E64', 'E2', 'ALL', 'POINT_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (163, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果开机容量为负数，忽略不计\r\n    if (openCapacity <=0) {\r\n      m.code = \"666\";\r\n      m.msg = \"���机容量为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m ;', 'E64', 'E2', 'ALL', 'POINT_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (164, 'RULES', 1, 'let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n\r\nif(ableValue<=electricCapacity*0.03 && forecastAbleValue<=electricCapacity*0.03){\r\n      m.code = \"666\";\r\n      m.msg = \"实际和预测值均在装机容量3%以内时，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code=\"200\";\r\n    m.msg=\"校验通过\";\r\n    return m;', 'E64', 'E2', 'ALL', 'POINT_ULTRA_SHORT_PASS', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (165, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E99', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (166, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E99', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (167, 'DEVIANCE_ELECTRIC', 1, 'devianceElectric(list,forecastAbleValue,ableValue,0.2)', 'E999', 'E1;E2', 'ALL', '', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (168, 'POINT_ULTRA_SHORT_AVERAGE_FORECAST', 1, '        let sum = 0;\r\n        for x in list {\r\n            sum = sum + x.forecastAbleValue;\r\n        }\r\n        return sum/16;', 'E999', 'E1;E2', 'ALL', '', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (169, 'POINT_ULTRA_SHORT_FORECAST_ERRORS', 1, '        let result = 0;\r\n        for x in list {\r\n            result = (x.forecastAbleValue- x.ableValue)/x.forecastAbleValue;\r\n            break;\r\n        }\r\n        return math.abs(result);', 'E999', 'E1;E2', 'ALL', '', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (170, 'POINT_SHORT_ACCURACY', 1, 'let result = 0;\r\n        for x in list {\r\n            result = 1-(math.abs(x.realValue-x.forecastAbleValue )/electricCapacity);\r\n            break;\r\n        }\r\n        return result ;', 'E32', 'E1;E2', 'ALL', '', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (214, 'POINT_ULTRA_SHORT_ACCURACY', 1, '        let result = 0;\r\n	let count = count(list);\r\n	let max = list[count-1];\r\n	result = 1-(math.abs(max.realValue-max.forecastAbleValue )/electricCapacity);\r\n        return result ;', 'E32', 'E1;E2', 'ALL', '', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (215, 'ASSESSMENT_SHORT_REPORT_RATE', 1, '(1-shortReportRate)*960*0.0005*powerGeneration*1', 'E34', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (216, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, '(1-ultraShortReportRate)*384*0.000005*powerGeneration*1', 'E34', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (217, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn (0.8-shortAccuracyRate)*ratedCapacity*0.1*0.2;\r\n\r\n\r\n', 'E34', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (218, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-ultraShortAccuracyRate)*ratedCapacity*0.1*0.1;\r\n', 'E34', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (219, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (powerGeneration == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"发电量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E34', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (220, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (powerGeneration == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"发电量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E34', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (221, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E34', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (222, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E34', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (223, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate==1){\r\n  return 0;\r\n}\r\n\r\nratedCapacity*0.25*powerGeneration*1', 'E42', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (224, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate==1){\r\n  return 0;\r\n}\r\n\r\nratedCapacity*0.25*powerGeneration*1', 'E42', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (225, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.87){\r\n  return 0;\r\n}\r\nreturn (0.87-shortAccuracyRate)*ratedCapacity*1.5;\r\n\r\n\r\n', 'E42', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (226, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.9){\r\n  return 0;\r\n}\r\nreturn (0.9-ultraShortReportRate)*ratedCapacity*1.5;\r\n\r\n\r\n', 'E42', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (227, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.83){\r\n  return 0;\r\n}\r\nreturn (0.83-shortAccuracyRate)*ratedCapacity*1;\r\n\r\n\r\n', 'E42', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (228, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.87){\r\n  return 0;\r\n}\r\nreturn (0.87-ultraShortReportRate)*ratedCapacity*1;', 'E42', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (229, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (230, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (231, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (232, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (233, 'SINGLE_MACHINE_PASS_RATE', 1, 'if(singleMachinePassRate>=0.99){\r\n  return 0;\r\n}\r\nreturn (0.99-singleMachinePassRate)*ratedCapacity*0.001;', 'E42', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (234, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=0.95){\r\n  return 0;\r\n}\r\n\r\nreturn (0.95-shortReportRate)*ratedCapacity*0.1*6;', 'E64', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (235, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=0.95){\r\n  return 0;\r\n}\r\n\r\nreturn (0.95-shortReportRate)*ratedCapacity*0.1*6;', 'E64', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (236, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn (0.8-shortAccuracyRate)*0.1*0.2;\r\n', 'E64', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (237, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn deviationPower*0.1*0.2;\r\n', 'E64', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (238, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.75){\r\n  return 0;\r\n}\r\nreturn deviationPower*0.1*0.2;\r\n', 'E64', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (239, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.75){\r\n  return 0;\r\n}\r\nreturn (0.75-ultraShortReportRate)*ratedCapacity*0.1*0.015;', 'E64', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (240, 'ABLE_POWER_ACCURACY_RATE', 1, 'if(ablePowerAccuracyRate>=0.98){\r\n  return 0;\r\n}\r\nreturn (0.98-ablePowerAccuracyRate)*ratedCapacity*0.1*0.05;', 'E64', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (241, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (singleMachinePassRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"单机合格率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'ALL', 'SINGLE_MACHINE_PASS_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (242, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E64', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (243, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E64', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (244, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (deviationPower == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"偏差电量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E64', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (245, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E64', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (246, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ablePowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E64', 'E1;E2', 'ALL', 'ABLE_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (247, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.002;', 'E41', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (248, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.001;', 'E41', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (249, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1;\r\n', 'E41', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (250, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.9){\r\n  return 0;\r\n}\r\nreturn (0.9-ultraShortReportRate)*ratedCapacity*0.1;', 'E41', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (251, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.83){\r\n  return 0;\r\n}\r\nreturn (0.83-shortAccuracyRate)*ratedCapacity*0.1;\r\n', 'E41', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (252, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.87){\r\n  return 0;\r\n}\r\nreturn (0.87-ultraShortReportRate)*ratedCapacity*0.1;', 'E41', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (254, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E41', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (255, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E41', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (256, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E41', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (257, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E41', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (258, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.002;', 'E37', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (259, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.001;', 'E37', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (260, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1;\r\n', 'E37', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (261, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.9){\r\n  return 0;\r\n}\r\nreturn (0.9-ultraShortReportRate)*ratedCapacity*0.1;', 'E37', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (262, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.83){\r\n  return 0;\r\n}\r\nreturn (0.83-shortAccuracyRate)*ratedCapacity*0.1;\r\n', 'E37', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (263, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.87){\r\n  return 0;\r\n}\r\nreturn (0.87-ultraShortReportRate)*ratedCapacity*0.1;', 'E37', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (264, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (265, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (266, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (267, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (268, 'SINGLE_MACHINE_PASS_RATE', 1, 'if(singleMachinePassRate>=0.985){\r\n  return 0;\r\n}\r\nreturn (0.985-singleMachinePassRate)*ratedCapacity*0.001*0.1;', 'E37', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (269, 'ABLE_POWER_ACCURACY_RATE', 1, 'if(ablePowerAccuracyRate>=0.985){\r\n  return 0;\r\n}\r\nreturn (0.985-ablePowerAccuracyRate)*ratedCapacity*0.001*0.1;', 'E37', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (270, 'THEORY_POWER_ACCURACY_RATE', 1, 'if(theoryPowerAccuracyRate>=0.985){\r\n  return 0;\r\n}\r\nreturn (0.985-theoryPowerAccuracyRate)*ratedCapacity*0.001*0.1;', 'E37', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (271, 'ANEMOMETER_TOWER_ACCURACY_RATE', 1, 'if(anemometerTower>=0.985){\r\n  return 0;\r\n}\r\nreturn (0.985-anemometerTowerAccuracyRate)*ratedCapacity*0.001*0.1;', 'E37', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (272, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (singleMachinePassRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"单机合格率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'SINGLE_MACHINE_PASS_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (273, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ablePowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'ABLE_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (274, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (theoryPowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"理论功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'THEORY_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (275, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (anemometerTowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"测风塔可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E37', 'E1;E2', 'ALL', 'ANEMOMETER_TOWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (276, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.001;', 'E13', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (277, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1*0.4;\r\n', 'E13', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (278, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1*0.4;\r\n', 'E13', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (279, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校���通过\";\r\n    return m;', 'E13', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (280, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E13', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (281, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.001;', 'E17', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (282, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.001;', 'E17', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (283, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1;\r\n', 'E17', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (284, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.9){\r\n  return 0;\r\n}\r\nreturn (0.9-ultraShortReportRate)*ratedCapacity*0.1;', 'E17', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (285, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E17', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (286, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E17', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (287, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E17', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (288, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E17', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (289, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E45old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (290, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E45old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (291, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn (0.8-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E45old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (292, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E45old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (293, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (294, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (295, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (296, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (297, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E45new', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (298, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E45new', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (299, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.6){\r\n  return 0;\r\n}\r\nreturn (0.6-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E45new', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (300, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E45new', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (301, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45new', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (302, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45new', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (303, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45new', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (304, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45new', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (305, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E44old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (306, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E44old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (307, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn (0.8-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E44old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (308, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E44old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (309, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (310, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (311, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (312, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (313, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E44new', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (314, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E44new', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (315, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.6){\r\n  return 0;\r\n}\r\nreturn (0.6-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E44new', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (316, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E44new', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (317, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44new', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (318, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44new', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (319, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44new', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (320, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44new', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (321, 'DAY_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E42', 'E1', 'J00313', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (322, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'meanAbsoluteError(list,ableValue,forecastAbleValue,electricCapacity)', 'E42', 'E1', 'J00313', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (323, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E42', 'E2', 'J00313', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (324, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorS(list,ableValue,forecastAbleValue,electricCapacity)', 'E42', 'E2', 'J00313', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (327, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n\r\n    ## 如果实际功率小于额定容量的3%，忽略不计\r\n    if (ableValue<0.03*electricCapacity) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率小于额定容量的3%，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'J00313', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (328, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (ableValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n\r\n    ## 如果实际功率小于额定容量的3%，忽略不计\r\n    if (ableValue<0.03*electricCapacity) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率小于额定容量的3%，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E42', 'E1;E2', 'J00313', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (329, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E45old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (330, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E45old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (331, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn (0.8-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E45old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (332, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E45old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (333, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E45old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (334, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.9){\r\n  return 0;\r\n}\r\nreturn (0.9-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E45old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (335, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (336, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (337, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (338, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (339, 'ASSESSMENT_MID_REPORT_RATE', 1, 'if(midReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-midReportRate)*ratedCapacity*0.1*0.5;', 'E45', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (340, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E45', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (341, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E45', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (342, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.45){\r\n  return 0;\r\n}\r\nreturn (0.45-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E45', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (343, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E45', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (344, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.7){\r\n  return 0;\r\n}\r\nreturn (0.7-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E45', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (345, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.4){\r\n  return 0;\r\n}\r\nreturn (0.4-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E45', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (346, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.6){\r\n  return 0;\r\n}\r\nreturn (0.6-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E45', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (347, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E45', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (348, 'SINGLE_MACHINE_PASS_RATE', 1, 'if(singleMachinePassRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-singleMachinePassRate)*ratedCapacity*0.01*0.005;', 'E45', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (349, 'ABLE_POWER_ACCURACY_RATE', 1, 'if(ablePowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-ablePowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E45', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (350, 'THEORY_POWER_ACCURACY_RATE', 1, 'if(theoryPowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-theoryPowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E45', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (351, 'ANEMOMETER_TOWER_ACCURACY_RATE', 1, 'if(anemometerTower>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-anemometerTowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E45', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (352, 'INSTALLED_CAPACITY_ACCURACY_RATE', 1, 'if(installedCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-installedCapacityAccuracyRate)*ratedCapacity*0.1*0.005;', 'E45', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (353, 'AVAILABLE_CAPACITY_ACCURACY_RATE', 1, 'if(availableCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-availableCapacityAccuracyRate)*ratedCapacity*0.1*0.001;', 'E45', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (354, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'ASSESSMENT_MID_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (355, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (356, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (357, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'ASSESSMENT_MID_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (358, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (359, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (360, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (singleMachinePassRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"单机合格率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'SINGLE_MACHINE_PASS_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (361, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ablePowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'ABLE_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (362, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (theoryPowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"理论功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'THEORY_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (363, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (anemometerTowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"测风塔可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'ANEMOMETER_TOWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (364, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (installedCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"装机容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'INSTALLED_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (365, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (availableCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'AVAILABLE_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (366, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E44old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (367, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E44old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (368, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn (0.8-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E44old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (369, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E44old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (370, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E44old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (371, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.9){\r\n  return 0;\r\n}\r\nreturn (0.9-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E44old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (372, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (373, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (374, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (375, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (376, 'ASSESSMENT_MID_REPORT_RATE', 1, 'if(midReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-midReportRate)*ratedCapacity*0.1*0.5;', 'E44', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (377, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E44', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (378, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E44', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (379, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.45){\r\n  return 0;\r\n}\r\nreturn (0.45-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E44', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (380, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E44', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (381, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.7){\r\n  return 0;\r\n}\r\nreturn (0.7-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E44', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (382, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.4){\r\n  return 0;\r\n}\r\nreturn (0.4-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E44', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (383, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.6){\r\n  return 0;\r\n}\r\nreturn (0.6-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E44', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (384, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E44', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (385, 'SINGLE_MACHINE_PASS_RATE', 1, 'if(singleMachinePassRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-singleMachinePassRate)*ratedCapacity*0.01*0.005;', 'E44', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (386, 'ABLE_POWER_ACCURACY_RATE', 1, 'if(ablePowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-ablePowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E44', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (387, 'THEORY_POWER_ACCURACY_RATE', 1, 'if(theoryPowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-theoryPowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E44', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (388, 'ANEMOMETER_TOWER_ACCURACY_RATE', 1, 'if(anemometerTower>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-anemometerTowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E44', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (389, 'INSTALLED_CAPACITY_ACCURACY_RATE', 1, 'if(installedCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-installedCapacityAccuracyRate)*ratedCapacity*0.1*0.005;', 'E44', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (390, 'AVAILABLE_CAPACITY_ACCURACY_RATE', 1, 'if(availableCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-availableCapacityAccuracyRate)*ratedCapacity*0.1*0.001;', 'E44', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (391, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'ASSESSMENT_MID_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (392, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (393, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (394, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'ASSESSMENT_MID_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (395, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (396, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (397, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (singleMachinePassRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"单机合格率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'SINGLE_MACHINE_PASS_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (398, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ablePowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'ABLE_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (399, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (theoryPowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"理论功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'THEORY_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (400, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (anemometerTowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"测风塔可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'ANEMOMETER_TOWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (401, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (installedCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"装机容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'INSTALLED_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (402, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (availableCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'AVAILABLE_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (403, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E52old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (404, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E52old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (405, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn (0.8-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E52old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (406, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E52old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (407, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E52old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (408, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.9){\r\n  return 0;\r\n}\r\nreturn (0.9-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E52old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (409, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (410, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (411, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (412, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (413, 'ASSESSMENT_MID_REPORT_RATE', 1, 'if(midReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-midReportRate)*ratedCapacity*0.1*0.5;', 'E52', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (414, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E52', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (415, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E52', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (416, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.45){\r\n  return 0;\r\n}\r\nreturn (0.45-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E52', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (417, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E52', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (418, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.7){\r\n  return 0;\r\n}\r\nreturn (0.7-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E52', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (419, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.4){\r\n  return 0;\r\n}\r\nreturn (0.4-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E52', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (420, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.6){\r\n  return 0;\r\n}\r\nreturn (0.6-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E52', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (421, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E52', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (422, 'SINGLE_MACHINE_PASS_RATE', 1, 'if(singleMachinePassRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-singleMachinePassRate)*ratedCapacity*0.01*0.005;', 'E52', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (423, 'ABLE_POWER_ACCURACY_RATE', 1, 'if(ablePowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-ablePowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E52', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (424, 'THEORY_POWER_ACCURACY_RATE', 1, 'if(theoryPowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-theoryPowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E52', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (425, 'ANEMOMETER_TOWER_ACCURACY_RATE', 1, 'if(anemometerTower>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-anemometerTowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E52', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (426, 'INSTALLED_CAPACITY_ACCURACY_RATE', 1, 'if(installedCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-installedCapacityAccuracyRate)*ratedCapacity*0.1*0.005;', 'E52', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (427, 'AVAILABLE_CAPACITY_ACCURACY_RATE', 1, 'if(availableCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-availableCapacityAccuracyRate)*ratedCapacity*0.1*0.001;', 'E52', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (428, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'ASSESSMENT_MID_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (429, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (430, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (431, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'ASSESSMENT_MID_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (432, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (433, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (434, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (singleMachinePassRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"单机合格率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'SINGLE_MACHINE_PASS_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (435, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ablePowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'ABLE_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (436, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (theoryPowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"理论功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'THEORY_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (437, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (anemometerTowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"测风塔可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'ANEMOMETER_TOWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (438, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (installedCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"装机容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'INSTALLED_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (439, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (availableCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'AVAILABLE_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (440, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E53old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (441, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E53old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (442, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn (0.8-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E53old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (443, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E53old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (444, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E53old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (445, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.9){\r\n  return 0;\r\n}\r\nreturn (0.9-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E53old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (446, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (447, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (448, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (449, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (450, 'ASSESSMENT_MID_REPORT_RATE', 1, 'if(midReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-midReportRate)*ratedCapacity*0.1*0.5;', 'E53', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (451, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E53', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (452, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E53', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (453, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.45){\r\n  return 0;\r\n}\r\nreturn (0.45-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E53', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (454, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E53', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (455, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.7){\r\n  return 0;\r\n}\r\nreturn (0.7-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E53', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (456, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.4){\r\n  return 0;\r\n}\r\nreturn (0.4-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E53', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (457, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.6){\r\n  return 0;\r\n}\r\nreturn (0.6-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E53', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (458, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E53', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (459, 'SINGLE_MACHINE_PASS_RATE', 1, 'if(singleMachinePassRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-singleMachinePassRate)*ratedCapacity*0.01*0.005;', 'E53', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (460, 'ABLE_POWER_ACCURACY_RATE', 1, 'if(ablePowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-ablePowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E53', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (461, 'THEORY_POWER_ACCURACY_RATE', 1, 'if(theoryPowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-theoryPowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E53', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (462, 'ANEMOMETER_TOWER_ACCURACY_RATE', 1, 'if(anemometerTower>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-anemometerTowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E53', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (463, 'INSTALLED_CAPACITY_ACCURACY_RATE', 1, 'if(installedCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-installedCapacityAccuracyRate)*ratedCapacity*0.1*0.005;', 'E53', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (464, 'AVAILABLE_CAPACITY_ACCURACY_RATE', 1, 'if(availableCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-availableCapacityAccuracyRate)*ratedCapacity*0.1*0.001;', 'E53', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (465, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'ASSESSMENT_MID_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (466, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (467, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (468, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'ASSESSMENT_MID_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (469, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (470, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (471, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (singleMachinePassRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"单机合格率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'SINGLE_MACHINE_PASS_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (472, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ablePowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'ABLE_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (473, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (theoryPowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"理论功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'THEORY_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (474, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (anemometerTowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"测风塔可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'ANEMOMETER_TOWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (475, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (installedCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"装机容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'INSTALLED_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (476, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (availableCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'AVAILABLE_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (477, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E46old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (478, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.2;', 'E46old', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (479, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.8){\r\n  return 0;\r\n}\r\nreturn (0.8-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E46old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (480, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E46old', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (481, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.85){\r\n  return 0;\r\n}\r\nreturn (0.85-shortAccuracyRate)*ratedCapacity*0.1*1;\r\n', 'E46old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (482, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.9){\r\n  return 0;\r\n}\r\nreturn (0.9-ultraShortReportRate)*ratedCapacity*0.1*1;', 'E46old', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (483, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (484, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (485, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46old', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (486, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46old', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (487, 'ASSESSMENT_MID_REPORT_RATE', 1, 'if(midReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-midReportRate)*ratedCapacity*0.1*0.5;', 'E46', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (488, 'ASSESSMENT_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E46', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (489, 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', 1, 'if(shortReportRate>=1){\r\n  return 0;\r\n}\r\n\r\nreturn (1-shortReportRate)*ratedCapacity*0.1*0.5;', 'E46', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (490, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.45){\r\n  return 0;\r\n}\r\nreturn (0.45-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E46', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (491, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E46', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (492, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.7){\r\n  return 0;\r\n}\r\nreturn (0.7-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E46', 'E1', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (493, 'ASSESSMENT_MID_ACCURACY_RATE', 1, 'if(midAccuracyRate>=0.4){\r\n  return 0;\r\n}\r\nreturn (0.4-midAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E46', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (494, 'ASSESSMENT_SHORT_ACCURACY_RATE', 1, 'if(shortAccuracyRate>=0.6){\r\n  return 0;\r\n}\r\nreturn (0.6-shortAccuracyRate)*ratedCapacity*0.1*0.2*1;\r\n', 'E46', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (495, 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', 1, 'if(ultraShortReportRate>=0.65){\r\n  return 0;\r\n}\r\nreturn (0.65-ultraShortReportRate)*ratedCapacity*0.1*0.2*1;', 'E46', 'E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (496, 'SINGLE_MACHINE_PASS_RATE', 1, 'if(singleMachinePassRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-singleMachinePassRate)*ratedCapacity*0.01*0.005;', 'E46', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (497, 'ABLE_POWER_ACCURACY_RATE', 1, 'if(ablePowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-ablePowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E46', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (498, 'THEORY_POWER_ACCURACY_RATE', 1, 'if(theoryPowerAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-theoryPowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E46', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (499, 'ANEMOMETER_TOWER_ACCURACY_RATE', 1, 'if(anemometerTower>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-anemometerTowerAccuracyRate)*ratedCapacity*0.1*0.005;', 'E46', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (500, 'INSTALLED_CAPACITY_ACCURACY_RATE', 1, 'if(installedCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-installedCapacityAccuracyRate)*ratedCapacity*0.1*0.005;', 'E46', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (501, 'AVAILABLE_CAPACITY_ACCURACY_RATE', 1, 'if(availableCapacityAccuracyRate>=0.95){\r\n  return 0;\r\n}\r\nreturn (0.95-availableCapacityAccuracyRate)*ratedCapacity*0.1*0.001;', 'E46', 'E1;E2', 'ALL', NULL, '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (502, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'ASSESSMENT_MID_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (503, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (504, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortReportRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期上报率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_REPORT_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (505, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (midAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"中期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'ASSESSMENT_MID_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (506, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (shortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'ASSESSMENT_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (507, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ultraShortAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"超短期准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'ASSESSMENT_ULTRA_SHORT_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (508, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (singleMachinePassRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"单机合格率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'SINGLE_MACHINE_PASS_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (509, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (ablePowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'ABLE_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (510, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (theoryPowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"理论功率准确率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'THEORY_POWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (511, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (anemometerTowerAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"测风塔可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'ANEMOMETER_TOWER_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (512, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (installedCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"装机容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'INSTALLED_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (513, 'RULES', 1, '	let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n	if (availableCapacityAccuracyRate == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"可用容量可用率为空\";\r\n      return m;\r\n    }\r\n	if (ratedCapacity == nil) {\r\n      m.code = \"500\";\r\n      m.msg = \"额定容量为空\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'AVAILABLE_CAPACITY_ACCURACY_RATE', '0', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (514, 'DAY_MID_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E44', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (515, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E44', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (516, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E44', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (517, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'DAY_MID_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (518, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (519, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E44', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (520, 'DAY_MID_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E45', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (521, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E45', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (522, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E45', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (523, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'DAY_MID_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (524, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (525, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E45', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (526, 'DAY_MID_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E46', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (527, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E46', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (528, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E46', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (529, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'DAY_MID_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (530, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (531, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E46', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (532, 'DAY_MID_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E52', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (533, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E52', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (534, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E52', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (535, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'DAY_MID_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (536, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (537, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E52', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (538, 'DAY_MID_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E53', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (539, 'DAY_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E53', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (540, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorSouthernPowerGrid(list,ableValue,forecastAbleValue,electricCapacity,0.2)', 'E53', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (541, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'DAY_MID_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (542, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'DAY_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (543, 'RULES', 1, '    ## 设定返回map\r\n    let m = seq.map(\"code\", \"500\", \"msg\", \"校验不通过\", \"data\", \"0.00%\");\r\n    ## 如果实际功率为负数，忽略不计\r\n    if (realValue <0) {\r\n      m.code = \"666\";\r\n      m.msg = \"实际功率为负数，忽略不计\";\r\n      return m;\r\n    }\r\n    m.code = \"200\";\r\n    m.msg = \"校验通过\";\r\n    return m;', 'E53', 'E1;E2', 'ALL', 'DAY_ULTRA_SHORT_ACCURACY', '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `t_calculation_formula` VALUES (544, 'DAY_ULTRA_SHORT_ACCURACY', 1, 'rootMeanSquaredErrorC(list,ableValue,forecastAbleValue,openCapacity)', 'E21', 'E1;E2', 'ALL', NULL, '1', '1', NULL, NULL, NULL, NULL);

SET FOREIGN_KEY_CHECKS = 1;
